import { defineComponent as N, watch as D, toRefs as T, resolveComponent as _, openBlock as i, createBlock as h, withCtx as p, createElementBlock as g, Fragment as w, renderList as b, createCommentVNode as v, createVNode as j, createSlots as A, renderSlot as C } from "vue";
const B = /* @__PURE__ */ N({
  __name: "table",
  props: {
    defaultProps: { default: {
      children: "children",
      label: "label"
    } },
    tableHeader: { default: [] },
    tableData: { default: [] },
    toDoName: { default: "操作" },
    isSlot: { type: Boolean, default: !1 }
  },
  setup(u) {
    const d = u;
    D(
      () => d.defaultProps,
      (l) => {
        if (l && !c(Object.values(l), [
          "children",
          "label"
        ])) {
          const { tableHeader: e } = T(d);
          e.value = s(e.value, l);
        }
      },
      {
        immediate: !0,
        deep: !0
      }
    );
    const c = (l, o) => {
      const e = [
        "string",
        "number",
        "boolean",
        "null",
        "undefined",
        "symbol"
      ];
      let r = !1;
      return e.includes(typeof l) && e.includes(typeof o) && (r = l === o), (JSON.stringify(l) == JSON.stringify(o) || JSON.stringify(l.reverse()) == JSON.stringify(o)) && (r = !0), r;
    }, s = (l, o) => (l.forEach((e) => {
      if (e[o.label] && e[o.children])
        e.label = e[o.label], e.children = e[o.children], delete e[o.label], delete e[o.children], e.children && e.children.length > 0 && s(e.children, o);
      else
        return;
    }), l);
    return (l, o) => {
      const e = _("el-table-column"), r = _("el-table");
      return i(), h(r, {
        data: l.tableData,
        style: { width: "100%" }
      }, {
        default: p(() => [
          (i(!0), g(w, null, b(l.tableHeader, (t) => (i(), h(e, {
            prop: t.prop,
            label: t.label,
            key: t.prop,
            "show-overflow-tooltip": t.toolTip ? t.toolTip : !1,
            align: t.align ? t.align : "left",
            "header-align": t.headAlign ? t.headAlign : null,
            width: t.width ? t.width : "fit"
          }, {
            default: p(() => {
              var m;
              return [
                ((m = t.children) == null ? void 0 : m.length) > 0 ? (i(!0), g(w, { key: 0 }, b(t.children, (n, O) => (i(), h(e, {
                  "min-width": n.minWidth ? n.minWidth : "",
                  key: O,
                  prop: n.prop,
                  label: n.label,
                  "show-overflow-tooltip": n.toolTip ? n.toolTip : !1,
                  align: n.align ? n.align : "left",
                  "header-align": n.headAlign ? n.headAlign : null,
                  width: n.width ? n.width : "fit"
                }, {
                  default: p(() => {
                    var y;
                    return [
                      ((y = n.children) == null ? void 0 : y.length) > 0 ? (i(!0), g(w, { key: 0 }, b(n.children, (a, S) => (i(), h(e, {
                        "min-width": a.minWidth ? a.minWidth : "",
                        key: S,
                        prop: a.prop,
                        label: a.label,
                        "show-overflow-tooltip": a.toolTip ? a.toolTip : !1,
                        align: a.align ? a.align : "left",
                        "header-align": a.headAlign ? a.headAlign : null,
                        width: a.width ? a.width : "fit"
                      }, null, 8, ["min-width", "prop", "label", "show-overflow-tooltip", "align", "header-align", "width"]))), 128)) : v("", !0)
                    ];
                  }),
                  _: 2
                }, 1032, ["min-width", "prop", "label", "show-overflow-tooltip", "align", "header-align", "width"]))), 128)) : v("", !0)
              ];
            }),
            _: 2
          }, 1032, ["prop", "label", "show-overflow-tooltip", "align", "header-align", "width"]))), 128)),
          j(e, { label: l.toDoName }, A({ _: 2 }, [
            l.isSlot ? {
              name: "default",
              fn: p((t) => [
                C(l.$slots, "toDo", {
                  scope: t.row
                })
              ]),
              key: "0"
            } : void 0
          ]), 1032, ["label"])
        ]),
        _: 3
      }, 8, ["data"]);
    };
  }
}), J = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: B
}, Symbol.toStringTag, { value: "Module" })), W = /* @__PURE__ */ Object.assign({ "./table/table.vue": J }), f = (u) => {
  if (!f.installed) {
    f.installed;
    for (const [d, c] of Object.entries(W)) {
      const s = "t-" + d.replace("./", "").split("/")[0];
      u.component(s, c.default);
    }
  }
};
typeof window < "u" && window.vue && f(window.Vue);
const P = {
  install: f
};
export {
  P as default
};
